import unittest
import io
import contextlib
from unittest.mock import patch

from tmc import points

from tmc.utils import load, get_stdout
main = load('src.main', 'main')


@points('1.3')
class MainTest(unittest.TestCase):

    def test_00_something_is_printed(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        if not printed:
            self.fail('Et tulostanut mitään!')

    def test_01_prints_correct_first_row(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[0].strip()
        self.assertEqual(line, '* * * * *',msg='Et tulostanut neliötä oikein')

    def test_02_prints_correct_second_row(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[1].strip()
        self.assertEqual(line, '* * * * *',msg='Et tulostanut neliötä oikein')

    def test_03_prints_correct_third_row(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[2].strip()
        self.assertEqual(line, '* * * * *',msg='Et tulostanut neliötä oikein')

    def test_04_prints_correct_fourth_row(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[3].strip()
        self.assertEqual(line, '* * * * *',msg='Et tulostanut neliötä oikein')

    def test_05_prints_correct_fifth_row(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[4].strip()
        self.assertEqual(line, '* * * * *',msg='Et tulostanut neliötä oikein')

    def test_06_uses_loop(self):
        self.longMessage = False

        # Get absolute path to main file:
        import os
        test_path = os.path.dirname(os.path.realpath(__file__))
        main_path = os.path.abspath(os.path.join(test_path, "../src/main.py"))

        # Read contents of main:
        main_file = open(main_path, 'r')
        lines = main_file.readlines()
        lines = [line.split('#')[0] for line in lines] # Remove comments

        # Get list of words (alphanumeric strings) in lines:
        import re
        words = [word.lower() for line in lines for word in re.split('\W+', line)]
        self.assertTrue(('for' in words or 'while' in words), msg='Et käyttänyt silmukkarakennetta')

        main_file.close()

